git: 13aacd0c0cb6 - main - stress2: Added a test scenario

From: Peter Holm <pho_at_FreeBSD.org>
Date: Sun, 08 May 2022 07:56:50 UTC
The branch main has been updated by pho:

URL: https://cgit.FreeBSD.org/src/commit/?id=13aacd0c0cb6c1e6da41c0d10bf41c1ed51a28d2

commit 13aacd0c0cb6c1e6da41c0d10bf41c1ed51a28d2
Author:     Peter Holm <pho@FreeBSD.org>
AuthorDate: 2022-05-08 07:54:54 +0000
Commit:     Peter Holm <pho@FreeBSD.org>
CommitDate: 2022-05-08 07:54:54 +0000

    stress2: Added a test scenario
---
 tools/test/stress2/misc/all.exclude  |  1 +
 tools/test/stress2/misc/mdconfig5.sh | 55 ++++++++++++++++++++++++++++++++++++
 2 files changed, 56 insertions(+)

diff --git a/tools/test/stress2/misc/all.exclude b/tools/test/stress2/misc/all.exclude
index df687f47cfb0..986daf714d0d 100644
--- a/tools/test/stress2/misc/all.exclude
+++ b/tools/test/stress2/misc/all.exclude
@@ -28,6 +28,7 @@ lockf5.sh		Spinning threads seen						20160718
 ifconfig.sh		Bug 253824							20210322
 ifconfig2.sh		https://people.freebsd.org/~pho/stress/log/log0051.txt		20210210
 maxvnodes2.sh		https://people.freebsd.org/~pho/stress/log/log0083.txt		20210329
+mdconfig5.sh		https://people.freebsd.org/~pho/stress/log/log0159.txt		20220508
 memguard.sh		https://people.freebsd.org/~pho/stress/log/log0088.txt		20210402
 memguard2.sh		Waiting for fix commit
 memguard3.sh		Waiting for fix commit
diff --git a/tools/test/stress2/misc/mdconfig5.sh b/tools/test/stress2/misc/mdconfig5.sh
new file mode 100755
index 000000000000..b0b25cc5d64b
--- /dev/null
+++ b/tools/test/stress2/misc/mdconfig5.sh
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2022 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# Bug 257557 Garbage on disk (or USB memory stick) can cause GEOM taste ffs_sbget() to crash.
+# "panic: wrong length 4352 for sectorsize 512" seen:
+# https://people.freebsd.org/~pho/stress/log/log0159.txt
+
+. ../default.cfg
+
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+cc -o /tmp/flip -Wall -Wextra -O2 ../tools/flip.c || exit 1
+start=`date +%s`
+while [ $((`date +%s` - start)) -lt 120 ]; do
+	dd if=/dev/zero of=$diskimage bs=8m count=1 status=none
+	mdconfig -a -t vnode -f $diskimage -u $mdstart
+	newfs $newfs_flags /dev/md$mdstart > /dev/null
+	mdconfig -d -u $mdstart
+	for i in `jot 10`; do
+		/tmp/flip -n 4 $diskimage
+		mdconfig -a -t vnode -f $diskimage -u $mdstart &&
+		    mdconfig -d -u $mdstart
+	done
+done
+
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+rm -f $diskimage /tmp/flip
+exit 0